
 ///////////////////////////////
 //  Checks if PokeMod is on  //
 ///////////////////////////////
 bool:PMon()
	return PM_disabled ? false : get_ppcvar_num(pm_pokemod) ? true : false

 //////////////////////////////
 //  Checks if Saving is on  //
 //////////////////////////////
 bool:SaveXPon()
	return Safari() ? false : (get_ppcvar_num(pm_save) ? true : false)

 //////////////////////////////
 //  Checks if Saving is on  //
 //////////////////////////////
 bool:Safari()
	return get_ppcvar_num(pm_safari_mode) ? true : false

 /////////////////////////////////////
 //  Checks if Friendly Fire is on  //
 /////////////////////////////////////
 bool:FFon()
	return get_pcvar_num(mp_friendlyfire) ? true : false

 /////////////////////////////////////
 //  Checks to see if they spawned  //
 //       in Oak/someone else       //
 /////////////////////////////////////
 public Oak_Check(id)
 {
	id -= 777
	if(is_user_alive(id)){
		new Float:porigin[3]
		new Float:vicinity = 100.0		//players dimentions (32x32x96), but just incase for some reasons, they get stuck by a little, lets make it 100
		new playersInVicinity = 0
		new entList[1]

		pev(id, pev_origin, porigin)

		playersInVicinity += fm_find_sphere_class(0, "player", vicinity, entList, 1, porigin)
		playersInVicinity += fm_find_sphere_class(0, "npc_pokecenter", vicinity, entList, 1, porigin)

		if(playersInVicinity > 1){
			poke_UnStuck(id)
			debugMessage(id,2,"spawned in something.")
		}
	}
 }
 
 //////////////////////////////////////////////
 //  Checks if they are near oak/in buyzone  //
 //////////////////////////////////////////////
 BuyCheck(id)
 {
	if(PMon()){
		if(!is_user_alive(id))
			return 1
		else{
			if(NearOakCheck(id)>0){
				if(CanBuy){
					return 1
				}
				else {
					client_print(id, print_center, "%d seconds have passed. \nYou can't buy anything now!", floatround(get_ppcvar_float(pm_buytime)*60))
				}
			}
			#if MOD==CS
			else if(cs_get_user_buyzone(id)){
				if(CanBuy){
					return 1
				}
				else {
					client_print(id, print_center, "%d seconds have passed. \nYou can't buy anything now!", floatround(get_ppcvar_float(pm_buytime)*60))
				}
			}
			#endif
		}
	}
	return 0
 }
 
 ///////////////////////////////////
 //  Checks if they are near oak  //
 ///////////////////////////////////
 NearOakCheck(id)
 {
	if(!PMon())
		return -1
	if(is_user_alive(id)){
		new pokedist = get_ppcvar_num(pm_pokecenter), Float:dist = 2.0*pokedist

		for(new i=0; i<MAX_OAKS; i++){
			if(ValidPC(i)){
				if(dist>pokedist)
					dist = fm_entity_range(id,PCent[i])

				if(dist<=pokedist){
					new oak_props[MAX_OAKPROP]
					pev(PCent[i], pev_globalname, oak_props, MAX_OAKPROP-1)
					if(containi(oak_props, "c")==-1 || (containi(oak_props, "c")!=-1 && (Team(PCent[i])==0 || Team(id)==Team(PCent[i]))))
						return PCent[i]
				}
			}
		}
	}
	else
		return 0
	return -1
 }
 
 /////////////////////////////////////////
 //  Returns multiplier for pokedamage  //
 /////////////////////////////////////////
 Float:TypeCheck(attacker, victim, atype=_:MAX_TYPES, vtype=_:MAX_TYPES )
 {
	if( atype == _:MAX_TYPES )
		atype = TotalTypes( Pokemon[attacker] );
	if( vtype == _:MAX_TYPES )
		vtype = TotalTypes( Pokemon[victim] );

	new Float:green = 2.0, Float:orange = 0.5, Float:red = 0.0, Float:blank = 1.0;
	new Float:banana = blank;

	//This returns the multiplier for the damage

	if( atype & (1<<_:TYPE_GRASS) ){
		if(vtype & (1<<_:TYPE_WATER) || vtype & (1<<_:TYPE_ROCK) || vtype & (1<<_:TYPE_GROUND))
			banana *= green
		if(vtype & (1<<_:TYPE_GRASS) || vtype & (1<<_:TYPE_FIRE) || vtype & (1<<_:TYPE_BUG) || vtype & (1<<_:TYPE_POISON) || vtype & (1<<_:TYPE_FLYING) || vtype & (1<<_:TYPE_DRAGON))
			banana *= orange
	}
	if( atype & (1<<_:TYPE_FIRE) ){
		if(vtype & (1<<_:TYPE_GRASS) || vtype & (1<<_:TYPE_BUG) || vtype & (1<<_:TYPE_ICE))
			banana *= green
		if(vtype & (1<<_:TYPE_FIRE) || vtype & (1<<_:TYPE_WATER) || vtype & (1<<_:TYPE_ROCK) || vtype & (1<<_:TYPE_DRAGON))
			banana *= orange
	}
	if( atype & (1<<_:TYPE_WATER) ){
		if(vtype & (1<<_:TYPE_FIRE) || vtype & (1<<_:TYPE_ROCK) || vtype & (1<<_:TYPE_GROUND))
			banana *= green
		if(vtype & (1<<_:TYPE_GRASS) || vtype & (1<<_:TYPE_WATER) || vtype & (1<<_:TYPE_DRAGON))
			banana *= orange
	}
	if( atype & (1<<_:TYPE_ELECTRIC) ){
		if(vtype & (1<<_:TYPE_WATER)|| vtype & (1<<_:TYPE_FLYING))
			banana *= green
		if(vtype & (1<<_:TYPE_GRASS) || vtype & (1<<_:TYPE_ELECTRIC) || vtype & (1<<_:TYPE_DRAGON))
			banana *= orange
		if(vtype & (1<<_:TYPE_GROUND))
			banana *= red
	}
	if( atype & (1<<_:TYPE_ROCK) ){
		if(vtype & (1<<_:TYPE_FIRE) || vtype & (1<<_:TYPE_ICE) || vtype & (1<<_:TYPE_FLYING) || vtype & (1<<_:TYPE_BUG))
			banana *= green
		if(vtype & (1<<_:TYPE_FIGHTING) || vtype & (1<<_:TYPE_GROUND))
			banana *= orange
	}

	if( atype & (1<<_:TYPE_PSYCHIC) ){
		if(vtype & (1<<_:TYPE_POISON) || vtype & (1<<_:TYPE_FIGHTING))
			banana *= green
		if(vtype & (1<<_:TYPE_PSYCHIC))
			banana *= orange
	}
	if( atype & (1<<_:TYPE_BUG) ){
		if(vtype & (1<<_:TYPE_GRASS) || vtype & (1<<_:TYPE_PSYCHIC) || vtype & (1<<_:TYPE_POISON))
			banana *= green
		if(vtype & (1<<_:TYPE_FIRE) || vtype & (1<<_:TYPE_FIGHTING) || vtype & (1<<_:TYPE_FLYING) || vtype & (1<<_:TYPE_GHOST))
			banana *= orange
	}
	if( atype & (1<<_:TYPE_POISON) ){
		if(vtype & (1<<_:TYPE_GRASS) || vtype & (1<<_:TYPE_BUG))
			banana *= green
		if(vtype & (1<<_:TYPE_ROCK) || vtype & (1<<_:TYPE_GROUND) || vtype & (1<<_:TYPE_POISON) || vtype & (1<<_:TYPE_GHOST))
			banana *= orange
	}
	if( atype & (1<<_:TYPE_GHOST) ){
		if(vtype & (1<<_:TYPE_GHOST))
			banana *= green
	}
	if( atype & (1<<_:TYPE_DRAGON) ){
		if(vtype & (1<<_:TYPE_DRAGON))
			banana *= green
	}
	if( atype & (1<<_:TYPE_NORMAL) ){
		if(vtype & (1<<_:TYPE_ROCK))
			banana *= orange
		if(vtype & (1<<_:TYPE_GHOST))
			banana *= red
	}
	if( atype & (1<<_:TYPE_ICE) ){
		if(vtype & (1<<_:TYPE_WATER) || vtype & (1<<_:TYPE_ICE))
			banana *= orange
		if(vtype & (1<<_:TYPE_GRASS) || vtype & (1<<_:TYPE_FLYING) || vtype & (1<<_:TYPE_DRAGON))
			banana *= green
	}
	if( atype & (1<<_:TYPE_FIGHTING) ){
		if(vtype & (1<<_:TYPE_POISON) || vtype & (1<<_:TYPE_FLYING) || vtype & (1<<_:TYPE_PSYCHIC) || vtype & (1<<_:TYPE_BUG))
			banana *= orange
		if(vtype & (1<<_:TYPE_NORMAL) || vtype & (1<<_:TYPE_ICE) || vtype & (1<<_:TYPE_ROCK))
			banana *= green
		if(vtype & (1<<_:TYPE_GHOST))
			banana *= red
	}
	if( atype & (1<<_:TYPE_GROUND) ){
		if(vtype & (1<<_:TYPE_GRASS) || vtype & (1<<_:TYPE_BUG))
			banana *= orange
		if(vtype & (1<<_:TYPE_FIRE) || vtype & (1<<_:TYPE_ELECTRIC) || vtype & (1<<_:TYPE_ROCK) || vtype & (1<<_:TYPE_POISON))
			banana *= green
		if(vtype & (1<<_:TYPE_FLYING))
			banana *= red
	}
	if( atype & (1<<_:TYPE_FLYING) ){
		if(vtype & (1<<_:TYPE_ELECTRIC) || vtype & (1<<_:TYPE_ROCK))
			banana *= orange
		if(vtype & (1<<_:TYPE_GRASS) || vtype & (1<<_:TYPE_FIGHTING) || vtype & (1<<_:TYPE_BUG))
			banana *= green
	}
	return banana
 }
 
 ///////////////////////////////////
 //  If someone can do something  //
 ///////////////////////////////////
 PassTest(id, num)
 {
	#if MOD==CS
	new clip, ammo, wpnid = get_user_weapon(id, clip, ammo)

	if(wpnid == CSW_C4){
		client_print(id,print_chat,"%s You cannot do this while holding a C4.",PREFIX)
		return false
	}
	#endif

	if (num > 0 && fm_ViewContents(id) == CONTENTS_SKY) {
		client_print(id,print_chat,"%s You cannot do this while aiming at the sky.",PREFIX)
		return false
	}
	return true
 }
 //////////////////////////////////////////////////////////////////////////////
 //  Checks if the pokemon is heavy (mainly for skills that move the player  //
 //////////////////////////////////////////////////////////////////////////////
 HeavyPoke(num)
 {
	switch(num)
	{
		case SNORLAX,NIDOKING,NIDOQUEEN,RHYDON,RHYHORN,VENUSAUR,MACHAMP,POLIWRATH,GOLEM: return true
	}
	return false
 }
 
 ///////////////////////////////////
 //  checks type of players poke  //
 ///////////////////////////////////
 PokeType( pid, POKE_TYPE:type )
 {
	switch(type)
	{
		case TYPE_GRASS:	return ( PokeInfo[pid] & PI_GRASS );
		case TYPE_FIRE:		return ( PokeInfo[pid] & PI_FIRE );
		case TYPE_WATER:	return ( PokeInfo[pid] & PI_WATER );
		case TYPE_ROCK:		return ( PokeInfo[pid] & PI_ROCK );
		case TYPE_ELECTRIC:	return ( PokeInfo[pid] & PI_ELECTRIC );
		case TYPE_PSYCHIC:	return ( PokeInfo[pid] & PI_PSYCHIC );
		case TYPE_BUG:		return ( PokeInfo[pid] & PI_BUG );
		case TYPE_POISON:	return ( PokeInfo[pid] & PI_POISON );
		case TYPE_GHOST:	return ( PokeInfo[pid] & PI_GHOST );
		case TYPE_NORMAL:	return ( PokeInfo[pid] & PI_NORMAL );
		case TYPE_ICE:		return ( PokeInfo[pid] & PI_ICE );
		case TYPE_FIGHTING:	return ( PokeInfo[pid] & PI_FIGHTING );
		case TYPE_GROUND:	return ( PokeInfo[pid] & PI_GROUND );
		case TYPE_FLYING:	return ( PokeInfo[pid] & PI_FLYING );
		case TYPE_DRAGON:	return ( PokeInfo[pid] & PI_DRAGON );
	}
	return false;
 }
 TotalTypes( pid )
 {
	new total;
	for( new POKE_TYPE:i=TYPE_NONE; i<MAX_TYPES; i++ )
		if( PokeType( pid, i ) )
			total |= (1<<_:i);
	return total;
 }
 
 ////////////////////
 //  Checks Maxhp  //
 ////////////////////
 public CheckMaxHP(id)
 {
	if(!is_user_connected(id))
		return

	if( maxhp[id] >= 0 ){
		new servermax = get_ppcvar_num(pm_maxhp)

		new bonus

		for(new i=0; i<ItemsCreated; i++)
			bonus += ItemMaxHP[i]*HasPokeItem(id, i)

		bonus += AverageLevel(id)

		new start = 100
		//aliens in NS have different starting HPs
		#if MOD==NS
			switch(ns_get_class(id))
			{
				case CLASS_SKULK: start = 70
				case CLASS_GORGE: start = 150
				case CLASS_LERK: start = 125
				case CLASS_FADE: start = 300
				case CLASS_ONOS: start = 700
				case CLASS_GESTATE: start = 200
				default: start = 100
			}
		#endif

		maxhp[id] = start+bonus

		if(maxhp[id] > servermax){
			client_print(id, print_chat, "%s This server's max HP is %d.",PREFIX, servermax)
			maxhp[id] = servermax
		}
	}
	set_pev(id, pev_max_health, float( abs( maxhp[id] ) ) )
 }
 
 /////////////////////////////////////////
 //  Gives a chance based on users lvl  //
 /////////////////////////////////////////
 Chance(id)
	return PokeChance(id, -1);

 //////////////////////////////////////////////////////
 //  Gives a chance based on users lvl of a pokemon  //
 //////////////////////////////////////////////////////
 PokeChance(id, pnum)
	return ( PlayersLevel(id, pnum) > random_num(0, TotalLevels + 1) );

 ///////////////////////////////////////////////////////
 //  Gives a percent based on users lvl of a pokemon  //
 ///////////////////////////////////////////////////////
 LevelPercent(id, num, pnum)
	return (( num * PlayersLevel(id,pnum) ) / ( TotalLevels + 1 ));
 Float:f_LevelPercent(id, Float:num, pnum)
	return (( num * PlayersLevel(id,pnum) ) / ( TotalLevels + 1 ));

 /////////////////////////////////////////////////////
 //  Gives a chance based on users lvl, with a max  //
 /////////////////////////////////////////////////////
 MaxChance(id, max)
 {
	static maxchance, lvl, num
	lvl = PlayersLevel(id, PlayersActive[id])
	if(max>0)
		maxchance = (100 * ( TotalLevels + 1 ) ) / max
	else
		maxchance = 100 * (TotalLevels+1)
	num = random(maxchance+1)

	return ( lvl > num ) ? true : false
 }
 
 ///////////////////////////
 //  If user has pokemon  //
 ///////////////////////////
 HasPokemon(id, pid, bool:checkall=false)
 {
	if( pid <= 0 )
		return -1

	static i;

	if(checkall){
		for( i=0; i<MAX_POKES; i++)
			if(PlayersPoke[id][i]==pid)
				return i;
	}
	else{
		for( i=0; i<MAX_ACTIVE_POKES; i++)
			if(PlayersPoke[id][i]==pid)
				return i;
	}
	if(Pokemon[id]==pid)
		return -2;
	return -1;
 }
 
 /////////////////////////////////
 //  Chance to catch a pokemon  //
 /////////////////////////////////
 CatchChance(id, poke, level)
 {
	#if MAX_CATCH_LEVEL > 0
	if( level > MAX_CATCH_LEVEL )
		return false
	#endif

	#if CATCH_SPECIAL == 0
		if(SpecialPoke(poke))
			return false
	#endif

	if(!poke || g_isWild[id]>0 || DisabledPoke(poke))
		return false

	new i, ran, flaga, flagb, catch

	switch( AvailableSlot(id, poke) )
	{
		case -2: flaga = 1
		case -1: flagb = 1
	}

	for( i = ItemsCreated; i >= 0; i-- )
	{
		while(HasPokeItem(id, i)){
			ran = random_num(0,TotalLevels + level)
			if( SpecialPoke(poke) )
				ran += random_num(0,level) //make it harder
			Item[id][i]--
			if(ItemCatch[i]>=ran || ItemCatch[i]>=100){
				catch = 1
				break
			}
		}
	}

	if( catch ){
		if( flagb ){
			client_print(id, print_chat, "%s You already have %d pokemon. Release some into the world to catch more.", PREFIX, MAX_ACTIVE_POKES)
			return false
		}
		if( flaga ){
			new pname[NAME_LENGTH]
			PokeToName(poke, pname)
			client_print(id, print_chat, "%s You caught a %s but decided to let it go because you already had one.", PREFIX, pname)
			return false
		}
		return true
	}

	return false
 }
 EntIsPC(ent)
 {
	for(new i=0; i<MAX_OAKS; i++){
		if( PCent[i] == ent && ValidPC(i) )
			return true;
	}
	return false;
 }
 ValidPC(num)
 {
	if( pev_valid( PCent[num] ) ){
		new class[32]
		pev( PCent[num], pev_classname, class, 31 );
		if(equali(class,"npc_pokecenter"))
			return true;
		else
			PCent[num] = 0;
	}
	return false;
 }
 knife_weapon(wpn)
 {
	#if MOD==CS
		if(wpn == CSW_KNIFE
		)
			return true;
	#endif
	#if MOD==DOD
		if(wpn == DODW_GERKNIFE
		|| wpn == DODW_AMERKNIFE
		|| wpn == DODW_SPADE
		)
			return true;
	#endif
	#if MOD==NS
		if(wpn == WEAPON_BITE
		|| wpn == WEAPON_BITE2
		|| wpn == WEAPON_SWIPE
		|| wpn == WEAPON_KNIFE
		|| wpn == WEAPON_CLAWS
		)
			return true;
	#endif
	return false;
 }
 grenade_weapon(wpn)
 {
	#if MOD==CS
		if(wpn == CSW_FLASHBANG
		|| wpn == CSW_HEGRENADE
		|| wpn == CSW_SMOKEGRENADE
		)
			return true;
	#endif
	#if MOD==DOD
		if(wpn == DODW_HANDGRENADE
		|| wpn == DODW_STICKGRENADE
		|| wpn == DODW_HANDGRENADE_EX
		|| wpn == DODW_STICKGRENADE_EX
		)
			return true;
	#endif
	#if MOD==NS
		if(wpn == WEAPON_GRENADE
		|| wpn == WEAPON_MINE
		)
			return true;
	#endif
	return false;
 }
 
 AvailableSlot(id, pid, checkall=0)
 {
	if(g_isWild[id]>0)
		return 0
	new i, has = 0
	switch(checkall)
	{
		case 1:{
			for(i=0; i<MAX_POKES;i++){
				if(PlayersPoke[id][i]==pid)
					return -2
				if(!PlayersPoke[id][i])
					return 1
				has++
			}
			if(has==MAX_POKES)
				return -1
		}
		case -1:{
			for(i=MAX_ACTIVE_POKES; i<MAX_POKES;i++){
				if(PlayersPoke[id][i]==pid)
					return -2
				if(!PlayersPoke[id][i])
					return 1
				has++
			}
			if(has==MAX_OAK_POKES)
				return -1
		}
		default:{
			for(i=0; i<MAX_ACTIVE_POKES;i++){
				if(PlayersPoke[id][i]==pid)
					return -2
				if(!PlayersPoke[id][i])
					return 1
				has++
			}
			if(has==MAX_ACTIVE_POKES)
				return -1
		}
	}
	return 0
 }
 
 Slot(id, pid=0, checkall=0)
 {
	static i;
	if(checkall==1){
		for( i=0; i<MAX_POKES; i++){
			if(PlayersPoke[id][i]==pid)
				return i
		}
	}
	else if(checkall==-1){
		for( i=MAX_ACTIVE_POKES; i<MAX_POKES; i++){
			if(PlayersPoke[id][i]==pid)
				return i
		}
	}
	else{
		for( i=0; i<MAX_ACTIVE_POKES; i++){
			if(PlayersPoke[id][i]==pid)
				return i
		}
	}
	return -1
 }
 
 //if someone is using a pokemon
 ActivePoke(id, poke)
 {
	if( Pokemon[id]==poke || (HasPokemon(id, poke)!=-1 && GlobalPoke(poke)) )
		return true
	return false
 }

 //if someone is pressing a pokemon with a bind
 UsingPoke(id, poke)
	return ( g_isSkilled[id] == poke );
 
 
 